'''BZTypeList module - classes of bz object'''

# Copyright (C) 2006: A.D.Foster
#
# ***** BEGIN GPL LICENSE BLOCK *****
#
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
# ***** END GPL LICENCE BLOCK *****				


class bzprim:
	position=[0.0,0.0,0.0]
	size=[10.0,10.0,10.0]
	rotation=[0.0]
	strings=('name','ingroup')
	attribs=('size','rotation','position')
	bools=('shootthrough','drivethrough','passable')
	materials=()
	params=()
	shootthrough=drivethrough=passable=False
	ingroup=''

class bzmesh:
	position=[0.0,0.0,0.0]
	size=[1.0,1.0,1.0]
	rotation=[0.0]
	shift=scale=spin=[]
	strings=('name','phydrv','ingroup','matref')
	attribs=('position','size','rotation','shift','scale','spin')
	bools=('shootthrough','drivethrough','passable','flatshading','smoothbounce')
	params=()	
	materials=()
	shootthrough=drivethrough=passable=flatshading=False
	ingroup=matref=phydrv=''
	top=bottom=inside=outside=startside=endside=edge=texsize=''
	
	

class base(bzprim):
	name='Base'
	color=[1]
	oncap=''
	size=[60.0,60.0,1.0]
	strings=('name','ingroup','oncap')
	attribs=('size','rotation','color','position')
	verts=(	[1.0,1.0,0.0],
			[1.0,-1.0,0.0],
			[-1.0,-1.0,0.0],
			[-1.0,1.0,0.0],
			[1.0,1.0,1.0],
			[1.0,-1.0,1.0],
			[-1,-1,1],
			[-1,1,1]
		    	)
	faces=(	[0,1,2,3], 	#base
			[7,6,5,4],	#top
			[0,3,7,4],	#+Y
			[1,5,6,2],	#-Y
			[0,4,5,1],	#+X
			[2,6,7,3],	#-X
		)
	params=()
	ingroup=''
	def type(self):
		return 'base'

		
class box(bzprim):
	name='Box'
	size=[30,30,9.42]
	verts=(	[1.0,1.0,0.0],
			[1.0,-1.0,0.0],
			[-1.0,-1.0,0.0],
			[-1.0,1.0,0.0],
			[1.0,1.0,1.0],
			[1.0,-1.0,1.0],
			[-1,-1,1],
			[-1,1,1]
		    	)
	faces=(	[0,1,2,3], 	#base
			[7,6,5,4],	#top
			[0,3,7,4],	#+Y
			[1,5,6,2],	#-Y
			[0,4,5,1],	#+X
			[2,6,7,3],	#-X
			)
	params=()
	def type(self):
		return 'box'
		
class pyramid(bzprim):
	bools=('shootthrough','drivethrough','passable','flipz')
	flipz=False
	size=[8.2,8.2,10.25]
	name='Pyramid'
	verts=(	[1.0,1.0,0.0],
			[1.0,-1.0,0.0],
			[-1.0,-1.0,0.0],
			[-1.0,1.0,0.0],
			[0.0,0.0,1.0]
		    	)
	faces=(	[0,1,2,3], 	#base
			[0,4,1],	#+X
			[2,4,3],	#-X
			[0,3,4],	#+Y
			[1,4,2],	#-Y
			)
	params=()
	def type(self):
		return 'pyramid'	

class group:
	name='GrpInst'
	shift=[0.0,0.0,0.0]
	scale=[1.0,1.0,1.0]
	shear=[0.0,0.0,0.0]
	spin=[0.0,0.0,0.0,0.0] 
	team=''    
	tint=''
	drivethrough=shootthrough=passable=False
	phydrv=matref=parent=''
	params=()
	materials=()
	strings=('name','phydrv','matref','parent','ingroup','team','tint')
	bools=('drivethrough','shootthrough','passable')
	attribs=('shift','scale','shear','spin')
	def type(self):
		return 'group'	
		
class define:
	name='GrpDef'
	strings=('name',)
	attribs=()
	params=()	
	bools=()
	materials=()
	objects=[]
	def type(self):
		return 'define'
	
class zone(bzprim):
	name='Zone'
	flag=team=safety=''
	size=[1.0,1.0,1.0]	
	attribs=('size','rotation','position')
	strings=('name','ingroup','flag','team','safety')
	verts=(	[1.0,1.0,0.0],
			[1.0,-1.0,0.0],
			[-1.0,-1.0,0.0],
			[-1.0,1.0,0.0],
			[1.0,1.0,1.0],
			[1.0,-1.0,1.0],
			[-1,-1,1],
			[-1,1,1]
		    	)
	faces=(	[0,1,2,3], 	#base
			[7,6,5,4],	#top
			[0,3,7,4],	#+Y
			[1,5,6,2],	#-Y
			[0,4,5,1],	#+X
			[2,6,7,3],	#-X
			)
	ingroup=''
	bools=()
	def type(self):
		return 'zone'	

class teleporter(bzprim):
	name='Tele'
	border='1.12'
	size=[0.56,20.16,4.48]
	attribs=('size','rotation','position','border')
	strings=('name','ingroup','telenum')
	verts=[	[1.0,1.0,0.0],
			[1.0,-1.0,0.0],
			[-1.0,-1.0,0.0],
			[-1.0,1.0,0.0],
			[1.0,1.0,1.0],
			[1.0,-1.0,1.0],
			[-1,-1,1],
			[-1,1,1]
		    	]
	faces=[	[0,1,2,3], 	#base
			[7,6,5,4],	#top
			[0,3,7,4],	#+Y
			[1,5,6,2],	#-Y
			[0,4,5,1],	#+X
			[2,6,7,3],	#-X
			]
	params=()
	bools=()
	ingroup=''
	def type(self):
		return 'teleporter'
		
class arc(bzmesh):
	name='Arc'
	attribs=('position','size','rotation','shift','scale','spin','divisions','angle','ratio')
	materials=('top','bottom','inside','outside','startside','endside')
	strings=('name','phydrv','ingroup','matref','texsize')
	divisions=[16]
	scale=[10.0,10.0,10.0]
	angle=[360.0]
	ratio=[1.0]
	def type(self):
		return 'arc'
		
class sphere(bzmesh):
	name='Sphere'
	divisions='4'
	radius=None
	scale=[10.0,10.0,10.0]
	attribs=('position','size','rotation','shift','scale','spin','divisions','radius')
	strings=('name','phydrv','ingroup','matref','texsize')
	def type(self):
		return 'sphere'
	
class cone(bzmesh):
	name='Cone'
	attribs=('position','size','rotation','shift','scale','spin','angle','divisions')
	materials=('edge','bottom','startside','endside')
	bools=('shootthrough','drivethrough','passable','flatshading','smoothbounce')
	strings=('name','phydrv','ingroup','matref','texsize')
	angle=[360.0]
	scale=[10.0,10.0,10.0]
	divisions=[16]
	texsize=''
	def type(self):
		return 'cone'
		
class meshbox(bzmesh):
	name='MeshBox'
	attribs=('position','size','rotation','shift','scale','spin','divisions','angle','ratio')
	materials=('top','bottom','inside','outside','startside','endside')
	strings=('name','phydrv','ingroup','matref','texsize')
	scale=[30.0,30.0,9.42]
	divisions=[4]
	angle=[360.0]
	ratio=[1.0]
	def type(self):
		return 'meshbox'
		
class material:
	name='Material'
	materials=()
	ambient=color=specular=emission=shininess=''
	matref=texture=addtexture=texmat=dyncol=''
	noradar=noshadoe=noculling=nosorting=nolighting=groupalpha=\
		occluder=notextures=notexalpha=notexcolor=spheremap=False
	alphathresh=''
	bools=(	'notextures','notexalpha','notexcolor','spheremap','noradar','noshadoe',
					'noculling','nosorting','nolighting','groupalpha','occluder')
	attribs=('ambient','color','specular','emission','shininess','alphathresh')
	strings=('texture','addtexture','texmat','dyncol','matref','name')
	params=()
	def type(self):
		return 'material'
		
class physics:
	bools=()
	params=()
	materials=()
	name='Physics'
	linear=angular=slide=death=''
	attribs=()
	strings=('name','linear','angular','slide','death')
	def type(self):
		return 'physics'
	
class meshpyr(bzmesh):
	name='MeshPyr'
	attribs=('position','size','rotation','shift','scale','spin','angle','divisions')
	materials=('edge','bottom','startside','endside')
	bools=('shootthrough','drivethrough','passable','flatshading','smoothbounce','flipz')
	strings=('name','phydrv','ingroup','matref','texsize')
	angle=[360.0]
	divisions=[4]
	scale=[8.2,8.2,10.25]
	texsize=''
	flipz=False
	def type(self):
		return 'meshpyr'
	
class tetra(bzmesh):
	name='Tetra'
	size=[1,1,1]
	attribs=('position','size','rotation','shift','scale','spin')
	strings=('name','phydrv','ingroup','matref')
	params=('vertex','texcoords','normals')
	vertex=[]
	normals=[]
	texcoords=[]
	def type(self):
		return 'tetra'	

class link:
	name='Link'
	strings=('name','ffrom','to')
	attribs=()
	ffrom=''
	to=''
	materials=()
	params=()
	bools=()
	def type(self):
		return 'link'	
		
class weapon:
	name='Weapon'
	position=[0.0,0.0,0.0]
	rotation=[0.0]
	tilt=[0.0]
	initdelay=delay=ttype=trigger=eventteam=''
	attribs=('position','rotation','tilt')
	strings=('initdelay','delay','ttype','trigger','eventteam','name')
	params=()
	bools=()
	materials=()
	def type(self):
		return 'weapon'
	
class world:
	name='World'
	size=[400]
	flagHeight=[10]
	attribs=('size','flagHeight')
	params=()
	bools=()
	strings=('name',)
	materials=()
	def type(self):
		return 'world'
		
class options:
	name='Options'
	params=()
	bools=()
	materials=()
	attribs=()
	strings=()
	def type(self):
		return 'options'

class mesh(bzmesh):
	name='Mesh'
	params=('vertex','inside','outside','normal','texcoord','face')
	bools=('shootthrough','drivethrough','passable','flatshading','smoothbounce','nocluster')
	vertex=[]
	inside=[]
	outside=[]
	texcoord=[]
	normal=[]
	face=[]
	def type(self):
		return 'mesh'

class face:
	attribs=('vertices','normals','texcoords')
	strings=('matref','phydrv')
	bools=('shootthrough','drivethrough','passable','smoothbounce')
	params=()
	materials=()
	shootthrough=drivethrough=passable=smoothbounce=False
	vertices=normals=texcoords=matref=phydrv=''
	def type(self):
		return 'face'
		
class waterLevel:
	name='WaterLevel'
	attribs=('height',)
	params=()
	bools=()
	strings=('name',)
	verts=([1.0,1.0,0.0],[1.0,-1.0,0.0],[-1.0,-1.0,0.0],[-1.0,1.0,0.0])
	faces=([0,1,2,3])
	height=[-1,]
	materials=()
	def type(self):
		return 'waterLevel'
		
		
class dynamicColor:#this way avoids seperate subclasses and extra parser conditionals
	name='DynCol'
	red_limits=red_sinusoid=red_clampUp=red_clampDown=red_sequence=''
	green_limits=green_sinusoid=green_clampUp=green_clampDown=green_sequence=''
	blue_limits=blue_sinusoid=blue_clampUp=blue_clampDown=blue_sequence=''
	alpha_limits=alpha_sinusoid=alpha_clampUp=alpha_clampDown=alpha_sequence=''
	strings=('name',
			'red_limits',	'red_sinusoid',		'red_clampUp',		'red_clampDown',	'red_sequence',
			'green_limits',	'green_sinusoid',	'green_clampUp',	'green_clampDown',	'green_sequence',
			'blue_limits',	'blue_sinusoid',	'blue_clampUp',		'blue_clampDown',	'blue_sequence',
			'alpha_limits',	'alpha_sinusoid',	'alpha_clampUp',	'alpha_clampDown',	'alpha_sequence')
	params=()
	bools=()
	attribs=()
	materials=()
	def type(self):
		return 'dynamicColor'

class	texmat:
	name='TexMat'
	scale=spin=shift=center=fixedscale=fixedspin=fixedshift=''
	strings=('scale','spin','shift','center','fixedscale','fixedspin','fixedshift','name')
	params=()
	bools=()
	attribs=()
	materials=()
	def type(self):
		return 'textureMatrix'

Objects={
		'box'					:box ,
		'pyramid'				:pyramid ,
		'base'					:base ,
		'define' 				:define ,
		'group'					:group,
		'link'					:link,
		'mesh'					:mesh,
		'arc'					:arc,
		'meshbox'				:meshbox,
		'cone'					:cone,
		'meshpyr'				:meshpyr,
		'sphere'				:sphere,
		'tetra'					:tetra,
		'weapon'				:weapon,
		'zone'					:zone,
		'waterLevel'			:waterLevel,
		'dynamicColor'			:dynamicColor,
		'textureMatrix'			:texmat,
		'material'				:material,
		'teleporter'			:teleporter,
		'physics'				:physics,
		'world'					:world,
		'options'				:options,
		'face'					:face
		}	


