"""module arc, takes a bzobject from the parser and creates a blender object."""

# Copyright (C) 2006: A.D.Foster
#
# ***** BEGIN GPL LICENSE BLOCK *****
#
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
# ***** END GPL LICENCE BLOCK *****

import Blender
from Blender import NMesh, Image, Object
import BZconfig
import BZcommon
from BZobject import bzmesh,BlObject
import BZtypeList
from BZcommon import retList



class importer(bzmesh):

	def __init__(self,bzobj):
		self.obj=bzobj
		name=self.obj.name[0]
		self.obj.name=name
	
	def run(self):
		scene = Blender.Scene.getCurrent ()
		Children=[]
		if self.obj.parent:
			group=Blender.Object.Get(self.obj.parent)
			childlist=retList(BZcommon.propertyCheck(group,'children'))
			i=1
			for obj in childlist:
				omesh=Blender.Mesh.Get(obj)
				nobj=Blender.Object.New('Mesh','M_%s_%s' % (self.obj.name,i))
				oobj=Blender.Object.Get(obj)
				oobj.copyAllPropertiesTo(nobj)
				BZcommon.propertyCheck(nobj,'bzflag','group_instance')
				nobj.setSize(oobj.getSize())
				nobj.setEuler(oobj.getEuler())
				nobj.setLocation(oobj.getLocation())
				omesh=Blender.Mesh.Get(obj)
				nobj.link(omesh)
				Children.append(nobj)
				scene.link(nobj)
				nobj.layers=[1]
				i+=1
		scobj=Object.New('Empty',self.obj.name)
		scobj.makeParent(Children)			
		scene.link (scobj)
		self.updateto()	
		Blender.Redraw()

class export(BlObject):
	def __init__(self,blobj,pipe):
		self.pipe=pipe
		self.out=BZtypeList.group()
		self.obj=blobj
	
	def run(self):
		ro=BZconfig.ro
		self.updateFrom()
		self.pipe.write('group %s\n' % self.out.parent)
		self.writeBools()
		self.writeStrings()
		self.writeAttribs()
		self.writeMesh()
		self.pipe.write('end\n\n')
		self.pipe.flush()
		
		



